package com.ruoyi.oa.service;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.oa.domain.UserMonthlyData;
import com.ruoyi.oa.domain.vo.SysOaTaskVo;
import com.ruoyi.oa.domain.bo.SysOaTaskBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 任务管理Service接口
 *
 * @author huangxing
 * @date 2024-01-11
 */
public interface ISysOaTaskService {

    /**
     * 查询任务管理
     */
    SysOaTaskVo queryById(Long taskId);

    /**
     * 查询任务管理列表
     */
    TableDataInfo<SysOaTaskVo> queryPageList(SysOaTaskBo bo, PageQuery pageQuery);

    /**
     * 查询任务管理列表
     */
    List<SysOaTaskVo> queryList(SysOaTaskBo bo);

    /**
     * 新增任务管理
     */
    Boolean insertByBo(SysOaTaskBo bo);

    /**
     * 修改任务管理
     */
    Boolean updateByBo(SysOaTaskBo bo);

    /**
     * 校验并批量删除任务管理信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 推迟任务申请
     * @param bo
     * @return
     */
    Boolean postponeTask(SysOaTaskBo bo);

    /**
     * 同意推迟
     * @param bo
     * @return
     */
    Boolean postponeSuccess(SysOaTaskBo bo);

    /**
     * 我的任务查询
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<SysOaTaskVo> queryPageListOwn(SysOaTaskBo bo, PageQuery pageQuery);

    /**
     * 增加一个推迟数量
     * @param taskId
     */
    void addPostpones(Long taskId);

    /**
     * 获取数值分析数据
     * @param month
     * @return
     */
    TableDataInfo<UserMonthlyData> getMonthlyData(String month);

    /**
     * 查询文件列表
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<SysOaTaskVo> queryPageListDocument(SysOaTaskBo bo, PageQuery pageQuery);

    /**
     * 查询未办任务
     *
     * @param sysOaTaskBo
     * @param pageQuery
     * @return
     */
    List<SysOaTaskVo> queryListByRemain(SysOaTaskBo sysOaTaskBo, PageQuery pageQuery);

    /**
     * 查询此项目挂接的所有文件
     *
     * @param projectId 项目id
     * @return
     */
    List<SysOaTaskVo> listDocumentProject(Long projectId);

}
